* gcc_release (BRANCH): Rename to...
[official-gcc.git] / maintainer-scripts / gcc_release
blob41fbfa98afb483f8ba523c026b833c4219a870fc
1 #! /bin/sh
3 ########################################################################
5 # File: gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date: 2001-05-25
9 # Contents:
10 # Script to create a GCC release.
12 # Copyright (c) 2001, 2002 Free Software Foundation.
14 # This file is part of GCC.
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
31 ########################################################################
33 ########################################################################
34 # Notes
35 ########################################################################
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
40 # gcc_release -r 3.0.2
42 # This script will automatically use the head of the release branch
43 # to generate the release.
45 ########################################################################
46 # Functions
47 ########################################################################
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
52 error() {
53 echo "gcc_release: error: $1"
54 exit 1
57 # Issue the informational message given by $1.
59 inform() {
60 echo "gcc_release: $1"
63 # Issue a usage message explaining how to use this script.
65 usage() {
66 cat <<EOF
67 gcc_release -r release [further options]
68 gcc_release -s [further options]
70 Options:
72 -r release Version of the form X.Y or X.Y.Z.
73 -s Create a snapshot, not a real release.
75 -d destination Local working directory where we will build the release
76 (default=${HOME}).
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
82 EOF
83 exit 1
86 # Change to the directory given by $1.
88 changedir() {
89 cd $1 || \
90 error "Could not change directory to $1"
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree. Return another name for that directory, relative
95 # to the working directory.
97 adjust_dirs() {
98 for x in $@; do
99 echo `basename ${SOURCE_DIRECTORY}`/$x
100 done
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
106 build_sources() {
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error "\`${WORKING_DIRECTORY}' already exists"
111 # Create the WORKING_DIRECTORY.
112 mkdir "${WORKING_DIRECTORY}" \
113 || error "Could not create \`${WORKING_DIRECTORY}'"
114 changedir "${WORKING_DIRECTORY}"
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform "Updating ChangeLogs and version files"
121 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122 -r ${CVSBRANCH} gcc || \
123 error "Could not check out release sources"
124 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125 # Update this ChangeLog file only if it does not yet contain the
126 # entry we are going to add. (This is a safety net for repeated
127 # runs of this script for the same release.)
128 if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then
129 cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE} Release Manager
132 * GCC ${RELEASE} released.
135 mv ${x}.new ${x} || \
136 error "Could not update ${x}"
137 (changedir `dirname ${x}` && \
138 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139 error "Could not commit ${x}"
141 done
143 # Update `gcc/version.c'.
144 for x in gcc/version.c; do
145 y=`basename ${x}`
146 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147 sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148 mv ${y}.new ${y} && \
149 ${CVS} ci -m 'Update version' ${y}) || \
150 error "Could not update ${x}"
151 done
153 # Make sure we tag the sources for a final release.
154 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
156 rm -rf ${SOURCE_DIRECTORY}
159 # Tag the sources.
160 if [ -n "${TAG}" ]; then
161 inform "Tagging release sources"
162 ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
163 error "Could not tag release sources"
164 CVSBRANCH=$TAG
167 # Export the current sources.
168 inform "Retrieving release sources"
169 ${CVS} \
170 export -d "`basename ${SOURCE_DIRECTORY}`" \
171 -r ${CVSBRANCH} gcc || \
172 error "Could not retrieve release sources"
174 # Run gcc_update on them to set up the timestamps nicely.
175 changedir "gcc-${RELEASE}"
176 contrib/gcc_update --touch
178 # Obtain some documentation files from the wwwdocs module.
179 inform "Retrieving HTML documentation"
180 changedir "${WORKING_DIRECTORY}"
181 for x in bugs faq; do
182 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
183 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
184 ${SOURCE_DIRECTORY}) || \
185 error "Could not retrieve ${x}.html"
186 done
188 inform "Generating plain-text documentation from HTML"
189 changedir "${SOURCE_DIRECTORY}"
190 for file in *.html; do
191 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
192 (${ENV} TERM=vt100 lynx -dump $file \
193 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
194 > $newfile) || \
195 error "Could not generate text-only version of ${file}"
196 done
198 # For a prerelease or real release, we need to generate additional
199 # files not present in CVS.
200 changedir "${SOURCE_DIRECTORY}"
201 if [ $SNAPSHOT -ne 1 ]; then
202 # Generate the documentation.
203 inform "Building install docs"
204 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
205 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
206 export SOURCEDIR
207 export DESTDIR
208 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
210 # Regenerate the NEWS file.
211 contrib/gennews > gcc/NEWS || \
212 error "Could not regenerate NEWS files"
214 # Now, we must build the compiler in order to create any generated
215 # files that are supposed to go in the source directory. This is
216 # also a good sanity check to make sure that the release builds
217 # on at least one platform.
218 inform "Building compiler"
219 OBJECT_DIRECTORY=../objdir
220 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
221 error "Could not rebuild GCC"
223 # Regenerate the Fotran NEWS and BUGS files.
224 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
225 error "Could not regenerate Fortran NEWS and BUGS files"
228 # Move message catalogs to source directory.
229 mv ../objdir/gcc/po/*.gmo gcc/po/
231 # Create a `.brik' file to use for checking the validity of the
232 # release.
233 changedir "${SOURCE_DIRECTORY}"
234 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
235 ((find . -type f | sort > $BRIK_FILE) && \
236 brik -Gb -f ${BRIK_FILE} > .brik && \
237 rm ${BRIK_FILE}) || \
238 error "Could not compute brik checksum"
241 # Buid a single tarfile. The first argument is the name of the name
242 # of the tarfile to build, without any suffixes. They will be added
243 # automatically. The rest of the arguments are the files or
244 # directories to include.
246 build_tarfile() {
247 # Get the name of the destination tar file.
248 TARFILE="$1.tar.bz2"
249 shift
251 # Build the tar file itself.
252 (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
253 error "Could not build tarfile"
254 FILE_LIST="${FILE_LIST} ${TARFILE}"
257 # Build the various tar files for the release.
259 build_tarfiles() {
260 inform "Building tarfiles"
262 changedir "${WORKING_DIRECTORY}"
264 # The GNU Coding Standards specify that all files should
265 # world readable.
266 chmod -R a+r ${SOURCE_DIRECTORY}
267 # And that all directories have mode 777.
268 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
270 # Build one huge tarfile for the entire distribution.
271 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
273 # Now, build one for each of the languages.
274 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
275 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
276 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
277 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
278 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
279 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
281 # The core is everything else.
282 EXCLUDES=""
283 for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
284 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
285 EXCLUDES="${EXCLUDES} --exclude $x"
286 done
287 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
288 `basename ${SOURCE_DIRECTORY}`
291 # Build .gz files.
292 build_gzip() {
293 for f in ${FILE_LIST}; do
294 target=${f%.bz2}.gz
295 (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
296 done
299 # Build diffs against an old release.
300 build_diffs() {
301 old_dir=${1%/*}
302 old_file=${1##*/}
303 old_vers=${old_file%.tar.bz2}
304 old_vers=${old_vers#gcc-}
305 inform "Building diffs against version $old_vers"
306 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
307 old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
308 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
309 if [ ! -e $old_tar ]; then
310 inform "$old_tar not found; not generating diff file"
311 elif [ ! -e $new_tar ]; then
312 inform "$new_tar not found; not generating diff file"
313 else
314 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
315 ${f}-${old_vers}-${RELEASE}.diff.bz2
317 done
320 # Build an individual diff.
321 build_diff() {
322 changedir "${WORKING_DIRECTORY}"
323 tmpdir=gccdiff.$$
324 mkdir $tmpdir || error "Could not create directory $tmpdir"
325 changedir $tmpdir
326 (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
327 (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
328 ${DIFF} $2 $4 > ../${5%.bz2}
329 if [ $? -eq 2 ]; then
330 error "Trouble making diffs from $1 to $3"
332 ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
333 changedir ..
334 rm -rf $tmpdir
335 FILE_LIST="${FILE_LIST} $5"
338 # Upload the files to the FTP server.
339 upload_files() {
340 inform "Uploading files"
342 changedir "${WORKING_DIRECTORY}"
344 # Make sure the directory exists on the server.
345 if [ $LOCAL -eq 0 ]; then
346 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
347 mkdir -p "${FTP_PATH}/diffs"
348 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
349 else
350 mkdir -p "${FTP_PATH}/diffs" \
351 || error "Could not create \`${FTP_PATH}'"
352 UPLOAD_PATH=${FTP_PATH}
355 # Then copy files to their respective (sub)directories.
356 for x in gcc*.gz gcc*.bz2; do
357 if [ -e ${x} ]; then
358 # Make sure the file will be readable on the server.
359 chmod a+r ${x}
360 # Copy it.
361 case ${x} in
362 *.diff.*)
363 SUBDIR="diffs/";
366 SUBDIR="";
367 esac
368 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
369 || error "Could not upload ${x}"
371 done
374 # Announce a snapshot, both on the web and via mail.
375 announce_snapshot() {
376 inform "Updating links and READMEs on the FTP server"
378 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
379 cd ~ftp/pub/gcc/snapshots
380 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
381 -e "s%@LONG_DATE@%$LONG_DATE%g" \
382 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
383 mv $$ README
384 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
385 -e "s%@LONG_DATE@%$LONG_DATE%g" \
386 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
387 mv $$ index.html
389 touch LATEST-IS-$LONG_DATE
390 rm -f LATEST-IS-$LAST_LONG_DATE
392 inform "Sending mail"
394 export QMAILHOST=gcc.gnu.org
395 mail -s "gcc-ss-$DATE is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
398 ########################################################################
399 # Initialization
400 ########################################################################
402 # Today's date.
403 DATE=`date "+%Y%m%d"`
404 LONG_DATE=`date "+%Y-%m-%d"`
406 # The CVS server containing the GCC repository.
407 CVS_SERVER="gcc.gnu.org"
408 # The path to the repository on that server.
409 CVS_REPOSITORY="/cvs/gcc"
410 # The CVS protocol to use.
411 CVS_PROTOCOL="ext"
412 # The username to use when connecting to the server.
413 CVS_USERNAME="${USER}"
415 # The machine to which files will be uploaded.
416 GCC_HOSTNAME="gcc.gnu.org"
417 # The name of the account on the machine to which files are uploaded.
418 GCC_USERNAME="gccadmin"
419 # The directory in which the files will be placed.
420 FTP_PATH="~ftp/pub/gcc"
422 # The major number for the release. For release `3.0.2' this would be
423 # `3'
424 RELEASE_MAJOR=""
425 # The minor number for the release. For release `3.0.2' this would be
426 # `0'.
427 RELEASE_MINOR=""
428 # The revision number for the release. For release `3.0.2' this would
429 # be `2'.
430 RELEASE_REVISION=""
431 # The complete name of the release.
432 RELEASE=""
434 # The name of the branch from which the release should be made, in a
435 # user-friendly form.
436 BRANCH=""
438 # The name of the branch from which the release should be made, as used
439 # for our version control system.
440 CVSBRANCH=""
442 # The tag to apply to the sources used for the release.
443 TAG=""
445 # The old tarballs from which to generate diffs.
446 OLD_TARS=""
448 # The directory that will be used to construct the release. The
449 # release itself will be placed in a subdirectory of this diretory.
450 DESTINATION=${HOME}
451 # The subdirectory.
452 WORKING_DIRECTORY=""
453 # The directory that will contain the GCC sources.
454 SOURCE_DIRECTORY=""
456 # The directories that should be part of the various language-specific
457 # tar files. These are all relative to the top of the source tree.
458 ADA_DIRS="gcc/ada"
459 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
460 FORTRAN_DIRS="gcc/f libf2c"
461 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
462 OBJECTIVEC_DIRS="gcc/objc libobjc"
463 TESTSUITE_DIRS="gcc/testsuite"
465 # Non-zero if this is the final release, rather than a prerelease.
466 FINAL=0
468 # Non-zero if we are building a snapshot, and don't build gcc or
469 # include generated files.
470 SNAPSHOT=0
472 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
473 # and copy directly to the FTP directory.
474 LOCAL=0
476 # Major operation modes.
477 MODE_GZIP=0
478 MODE_DIFFS=0
479 MODE_SOURCES=0
480 MODE_TARFILES=0
481 MODE_UPLOAD=0
483 # List of archive files generated; used to create .gz files from .bz2.
484 FILE_LIST=""
486 # Programs we use.
488 BZIP2="${BZIP2:-bzip2}"
489 CVS="${CVS:-cvs -f -Q -z9}"
490 DIFF="${DIFF:-diff -Nrc3pad}"
491 ENV="${ENV:-env}"
492 GZIP="${GZIP:-gzip --best}"
493 SCP="${SCP:-scp -p}"
494 SSH="${SSH:-ssh}"
495 TAR="${TAR:-tar}"
497 ########################################################################
498 # Command Line Processing
499 ########################################################################
501 # Parse the options.
502 while getopts "d:fr:u:t:p:sl" ARG; do
503 case $ARG in
504 d) DESTINATION="${OPTARG}";;
505 r) RELEASE="${OPTARG}";;
506 t) TAG="${OPTARG}";;
507 u) CVS_USERNAME="${OPTARG}";;
508 f) FINAL=1;;
509 s) SNAPSHOT=1;;
510 l) LOCAL=1
511 SCP=cp
512 FTP_PATH=~ftp/pub/gcc
513 PATH=~:/usr/local/bin:$PATH;;
514 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
515 if [ -d ${OPTARG} ]; then
516 error "-p argument must name a tarball"
517 fi;;
518 \?) usage;;
519 esac
520 done
521 shift `expr ${OPTIND} - 1`
523 # Perform consistency checking.
524 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
525 error "No username specified"
528 if [ ! -d ${DESTINATION} ]; then
529 error "\`${DESTINATION}' is not a directory"
532 if [ $SNAPSHOT -eq 0 ]; then
533 if [ -z ${RELEASE} ]; then
534 error "No release number specified"
537 # Compute the major and minor release numbers.
538 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
539 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
540 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
542 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
543 error "Release number \`${RELEASE}' is invalid"
546 # Compute the full name of the release.
547 if [ -z "${RELEASE_REVISION}" ]; then
548 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
549 else
550 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
553 # Compute the name of the branch, which is based solely on the major
554 # and minor release numbers.
555 CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
557 # If this is not a final release, set various parameters acordingly.
558 if [ ${FINAL} -ne 1 ]; then
559 RELEASE="${RELEASE}-${DATE}"
560 FTP_PATH="${FTP_PATH}/snapshots/"
561 else
562 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
564 else
565 RELEASE=$DATE
566 # For now snapshots come from the 3.3 branch.
567 BRANCH="3.3"
568 CVSBRANCH=gcc-3_3-branch
569 FTP_PATH="${FTP_PATH}/snapshots/${BRANCH}-${LONG_DATE}"
570 TAG=gcc_ss_${DATE}
572 # Building locally on gcc.gnu.org, we know what the last snapshot date
573 # was.
574 if [ $LOCAL -ne 0 ]; then
575 LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
576 LAST_LONG_DATE=`date --date=$LAST_DATE +%Y-%m-%d`
577 LAST_DIR=~ftp/pub/gcc/snapshots/${LAST_LONG_DATE}
578 OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.bz2
582 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
583 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
584 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
586 # Recompute the names of all the language-specific directories,
587 # relative to the WORKING_DIRECTORY.
588 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
589 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
590 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
591 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
592 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
593 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
595 # Set up CVSROOT.
596 if [ $LOCAL -eq 0 ]; then
597 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
598 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
599 else
600 CVSROOT="${CVS_REPOSITORY}"
602 export CVSROOT
604 ########################################################################
605 # Main Program
606 ########################################################################
608 # Set the timezone to UTC
609 TZ="UTC0"
610 export TZ
612 # Handle the major modes.
613 while [ $# -ne 0 ]; do
614 case $1 in
615 diffs) MODE_DIFFS=1;;
616 gzip) MODE_GZIP=1;;
617 sources) MODE_SOURCES=1;;
618 tarfiles) MODE_TARFILES=1;;
619 upload) MODE_UPLOAD=1;;
620 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
621 if [ $SNAPSHOT -ne 1 ]; then
622 # Only for releases and pre-releases.
623 MODE_GZIP=1;
626 *) error "Unknown mode $1";;
627 esac
628 shift
629 done
631 # Build the source directory.
633 if [ $MODE_SOURCES -ne 0 ]; then
634 build_sources
637 # Build the tar files.
639 if [ $MODE_TARFILES -ne 0 ]; then
640 build_tarfiles
643 # Build diffs
645 if [ $MODE_DIFFS -ne 0 ]; then
646 # Possibly build diffs.
647 if [ -n "$OLD_TARS" ]; then
648 for old_tar in $OLD_TARS; do
649 build_diffs $old_tar
650 done
654 # Build gzip files
655 if [ $MODE_GZIP -ne 0 ]; then
656 build_gzip
659 # Upload them to the FTP server.
661 if [ $MODE_UPLOAD -ne 0 ]; then
662 upload_files
664 # For snapshots, make some further updates.
665 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
666 announce_snapshot
668 # Update snapshot date file.
669 changedir ~
670 echo $DATE > .snapshot_date-${BRANCH}
672 # Remove working directory
673 rm -rf ${WORKING_DIRECTORY}